   LIST OFF
; ***  P A C - M A N  ***
; Copyright 1981 Atari,Inc.
; Programmer: Tod Frye

; Analyzed, labeled and commented
;  by Dennis Debro
; Last Update: June 14, 2004
;

   processor 6502
      
;
; NOTE: You must compile this with vcs.h version 105 or greater.
;
TIA_BASE_READ_ADDRESS = $30         ; set the read address base so this runs on
                                    ; the real VCS and compiles to the exact
                                    ; ROM image

   include ..\..\..\vcs.h

   LIST ON

;===============================================================================
; A S S E M B L E R - S W I T C H E S
;===============================================================================

NTSC                    = 0
PAL                     = 1

COMPILE_VERSION         = NTSC      ; change this to compile for different
                                    ; regions
   
CHEAT_ENABLED           = 0         ; set to 1 to disable deadly collisions

;============================================================================
; T I A - C O N S T A N T S
;============================================================================

HMOVE_L7          =  $70
HMOVE_L6          =  $60
HMOVE_L5          =  $50
HMOVE_L4          =  $40
HMOVE_L3          =  $30
HMOVE_L2          =  $20
HMOVE_L1          =  $10
HMOVE_0           =  $00
HMOVE_R1          =  $F0
HMOVE_R2          =  $E0
HMOVE_R3          =  $D0
HMOVE_R4          =  $C0
HMOVE_R5          =  $B0
HMOVE_R6          =  $A0
HMOVE_R7          =  $90
HMOVE_R8          =  $80

; values for NUSIZx:
ONE_COPY          = %000
TWO_COPIES        = %001
TWO_WIDE_COPIES   = %010
THREE_COPIES      = %011
DOUBLE_SIZE       = %101
THREE_MED_COPIES  = %110
QUAD_SIZE         = %111

; values for REFPx:
NO_REFLECT        = %0000
REFLECT           = %1000

; SWCHA joystick bits:
MOVE_RIGHT        = %10000000
MOVE_LEFT         = %01000000
MOVE_DOWN         = %00100000
MOVE_UP           = %00010000
NO_MOVE           = %11111111

; mask for SWCHB
P1_DIFF_MASK      = %10000000
BW_MASK           = %00001000       ; black and white bit
SELECT_MASK       = %00000010
RESET_MASK        = %00000001

;============================================================================
; U S E R - C O N S T A N T S
;============================================================================

; frame time values
VBLANK_TIME          = $29
OVERSCAN_TIME        = $4C

MID_PLAYFIELD_X      = 76

STARTING_BOX_X       = MID_PLAYFIELD_X
STARTING_BOX_Y       = 30
PACMAN_STARTING_Y    = 60
STARTING_NUM_LIVES   = 3    

MAX_Y                = 91

H_FONT               = 7
MAX_KERNEL_SECTIONS  = 7
GHOST_OFFSET         = 11

NORTH_POWER_PILL_Y   = 5
SOUTH_POWER_PILL_Y   = 65

POWER_PILL_WEST      = 4
POWER_PILL_EAST      = 148

VITAMIN_DURATION     = 18

GHOST_EATING_DELAY   = 159

;kernel section values
VITAMIN_SECTION      = 3
STARTING_BOX_SECTION = 4

;gameState values
PLAY_STARTING_MUSIC  = %00001000
FRUIT_VISIBLE        = %00000010

;point id's for lookup table
ID_FIRST_GHOST       = 0
ID_SECOND_GHOST      = 1
ID_THIRD_GHOST       = 2
ID_FORTH_GHOST       = 3
ID_VIDEO_WAFER       = 4
ID_POWER_PILL        = 5
ID_VITAMIN           = 6

;point values (BCD)
FIRST_GHOST_VALUE    = $0020
SECOND_GHOST_VALUE   = $0040
THIRD_GHOST_VALUE    = $0080
FOURTH_GHOST_VALUE   = $0160
VIDEO_WAFER_VALUE    = $0001
POWER_PILL_VALUE     = $0005
VITAMIN_VALUE        = $0100
   
GHOST_EYES_ATTRIBUTE = 8

;difficulty settings
EXPERT               = $20
AMATEUR              = $00

;============================================================================
; Z P - V A R I A B L E S
;============================================================================

frameCount              = $80
gameTimer               = $81       ; $81 - $82
selectDebounce          = $83
gameSelection           = $84

waferIndex              = $87
currentPlayerVars       = $88       ; $88 - $9B
mazeDots                = currentPlayerVars  ; $88 - $97
remainingLives          = mazeDots+16

temporaryPlayerVars     = $9C       ; $9C - $AF
tempMazeDots            = temporaryPlayerVars
tempRemainingLives      = tempMazeDots+16
currentGhostHorizPos    = $B0
objectHorizPos          = $B1       ; $B1 - $B5
pacmanHorizPos          = objectHorizPos
ghost0HorizPos          = objectHorizPos+1
ghost1HorizPos          = objectHorizPos+2
ghost2HorizPos          = objectHorizPos+3
ghost3HorizPos          = objectHorizPos+4

objectVertPos           = $B6       ; $B6 - $BA
pacmanVertPos           = objectVertPos
ghost0VertPos           = objectVertPos+1
ghost1VertPos           = objectVertPos+2
ghost2VertPos           = objectVertPos+3
ghost3VertPos           = objectVertPos+4

objectDirections        = $BB       ; $BB - $BF
pacmanDirection         = objectDirections
ghostDirections         = objectDirections+1
ghost0Direction         = ghostDirections
ghost1Direction         = ghostDirections+1
ghost2Direction         = ghostDirections+2
ghost3Direction         = ghostDirections+3

kernelSection           = $C9
mazeIndex               = $CA

playerScore             = $CC       ; $CC - $D1
playerScoreL0           = playerScore
playerScoreL1           = playerScore+1
playerScoreM0           = playerScore+2
playerScoreM1           = playerScore+3
playerScoreH0           = playerScore+4
playerScoreH1           = playerScore+5

kernelPFValues          = $D2       ; $D2 - $D7
kernelLeftPFValues      = kernelPFValues
kernelRightPFValues     = kernelPFValues+3
;--------------------------------------
leftPF0Value            = kernelLeftPFValues
leftPF1Value            = kernelLeftPFValues+1
leftPF2Value            = kernelLeftPFValues+2
rightPF0Value           = kernelRightPFValues
rightPF1Value           = kernelRightPFValues+1
rightPF2Value           = kernelRightPFValues+2
;--------------------------------------
digitPointers           = kernelRightPFValues ; $D5 - $DE

ghostOffset             = $D8
pacmanOffset            = $D9

ghostIndex              = $DB
pacmanIndex             = $DC
ghostPointer            = $DD       ; $DD - $DE
pacmanPointer           = $DF       ; $DF - $E0

kernelEnableVitamin     = $E1
;--------------------------------------
loopCount               = kernelEnableVitamin
digitPointerOffset      = $E2
;--------------------------------------
tempCharHolder          = digitPointerOffset
kernelPF2Value          = $E3

ghostEatingDelay        = $E5
playerState             = $E6       ; ct---?----
                                    ; c = current player (1 = player1 0 = player0)
                                    ; t = game type (0 = 1player 1 = 2player)
gameState               = $E7

vitaminTimer            = $EC
joystickValue           = $ED

backgroundColor         = $F0
playfieldColor          = $F1

;===============================================================================
; R O M - C O D E (Part 1)
;===============================================================================

   SEG code
   org $F000
   
Start
;
; Set up everything so the power up state is known.
;
   cld                              ; clear decimal mode
   sei                              ; disable interrupts
   ldx #$FF
   txs                              ; set stack to the beginning
   inx                              ; x = 0
   txa
.clearLoop
   sta VSYNC,x
   inx
   bne .clearLoop
   
   lda #$06
   sta gameSelection
   asl                              ; a = 3
   sta vitaminTimer
   dex
   stx gameTimer+1
   stx $CB
   
   jsr NewLevel
   
   lda #$CB                         ; BCD value for Copyright3 and Copyright4
   sta playerScoreL0
   lsr
   sta pacmanVertPos
   lda #$ED                         ; BCD value for Copyright1 and Copyright2
   sta playerScoreM0
   lda #$0F                         ; BCD value for 0 and Copyright 0
   sta playerScoreH0
   ldx #4
LF02C:
   sta $C0,x
   dex
   bne LF02C
   
   sta WSYNC                        ; wait for next scan line
   lda #HMOVE_R1
   sta HMM1                         ; set missile fine motion (vitamin)
   lda #HMOVE_R8
   sta HMBL                         ; set ball fine motion (vitamin)
   ldx #6
.coarseMoveVitamin
   dex
   bne .coarseMoveVitamin
   sta RESBL                        ; set ball to pixel 155
   sta RESM1                        ; set missile to pixel 157
   sta WSYNC                        ; wait for next scan line
   sta HMOVE                        ; move the ball and missile
   sta WSYNC                        ; wait for next scan line
   sta HMCLR                        ; clear all horizontal movements
   stx gameState
   stx $98
   jmp VerticalSync
       
DrawPacmanSprite SUBROUTINE
   lda #0                     ; 2
   cpx pacmanOffset           ; 3
   bmi .skipPacmanDraw        ; 2
   ldy pacmanIndex            ; 3
   bmi .skipPacmanDraw        ; 2
   lda (pacmanPointer),y      ; 5
   dey                        ; 2
   sty pacmanIndex            ; 3
.skipPacmanDraw
   sta WSYNC
;--------------------------------------
   sta GRP1                   ; 3 = @03
   rts                        ; 6

LF067: JSR    DrawPacmanSprite   ;6
DrawGhostSprite SUBROUTINE
   lda #0                     ; 2
   inx                        ; 2
   cpx ghostOffset            ; 3
   bmi .skipGhostDraw         ; 2
   ldy ghostIndex             ; 3
   bmi .skipGhostDraw         ; 2
   lda (ghostPointer),y       ; 5
   dey                        ; 2
   sty ghostIndex             ; 3
.skipGhostDraw
   sta WSYNC
;--------------------------------------
   sta GRP0                   ; 3 = @03
   rts                        ; 6

MainLoop
   sta WSYNC
;--------------------------------------
   lda #HMOVE_L2              ; 2
   sta NUSIZ0                 ; 3 = @05   one copy of player 0
   ldx #$00                   ; 2
   tay                        ; 2
   lda frameCount             ; 3         get the current frame count
   and #$08                   ; 2
   bne .coarseMoveEnergizers  ; 2
   ldx #9                     ; 2
   nop                        ; 2
.coarseMoveEnergizers
   dex                        ; 2
   bpl .coarseMoveEnergizers  ; 2
   sta RESM0                  ; 3
   sty HMM0                   ; 3
   sty NUSIZ1                 ; 3         one copy of player 1
   ldx #1                     ; 2
MoveGameSpritesHoriz
   lda #1                     ; 2
   clc                        ; 2
   adc currentGhostHorizPos,x ; 4
   ldy #2                     ; 2
   sec                        ; 2
.determineCoarseValue
   iny                        ; 2
   sbc #15                    ; 2
   bcs .determineCoarseValue  ; 2
   eor #$FF                   ; 2
   sbc #6                     ; 2
   asl                        ; 2         shift fine position value to upper
   asl                        ; 2         nybbles
   asl                        ; 2
   asl                        ; 2
   sta WSYNC
;--------------------------------------
.coarseMoveObject
   dey                        ; 2
   bpl .coarseMoveObject      ; 2
   sta RESP0,x                ; 4         set object's coarse position
   sta HMP0,x                 ; 4         set object's fine position
   dex                        ; 2
   bpl MoveGameSpritesHoriz   ; 2
   sta WSYNC
;--------------------------------------
   sta HMOVE
   ldy #$01
   ldx #MAX_KERNEL_SECTIONS
       
DisplayKernel SUBROUTINE
.waitTime
   lda INTIM
   bne .waitTime

   sta WSYNC                  ;           end current scan line
;--------------------------------------
   sty VBLANK                 ; 3 = @03   turn on TIA (D1 = 0)
   sta HMCLR                  ; 3 = @06   clear horizontal movements
   lda backgroundColor        ; 3
   sta COLUBK                 ; 3 = @12   set the background color
   sty mazeIndex              ; 3         set mazeIndex to 1
   dey                        ; 2
   sty waferIndex             ; 3         set waferIndex to 0
   stx kernelSection          ; 3         set kernel section to start
   inx                        ; 2
   lda #%00110001             ; 2
   sta CTRLPF                 ; 3 = @30   ball is 8 clocks wide no PF reflect
   
   lda playfieldColor         ; 3
   sta COLUPF                 ; 3 = @36   color the playfield
;--------------------------------------
   jsr DrawGhostSprite        ; 9
   ldy #%11111111             ; 2
   sty PF0                    ; 3 = @14   draw the top portion of the maze
   sty PF1                    ; 3 = @17
   lda #%01111111             ; 2         space is used for the tunnel
   sta PF2                    ; 3 = @22
   jmp LF313                  ; 3
   
LF0F4
   lda #0                     ; 2
   cpx pacmanOffset           ; 3
   bmi LF103                  ; 2+1
   ldy pacmanIndex            ; 3
   bmi LF103                  ; 2+1
   lda (pacmanPointer),y      ; 5
   dey                        ; 2
   sty pacmanIndex            ; 3
LF103:
   sta WSYNC
;--------------------------------------
   sta GRP1                   ; 3 = @03
   ldy mazeIndex              ; 3
   dey                        ; 2
   beq LF176                  ; 2
   ldy waferIndex             ; 3
   lda mazeDots,y             ; 4
   and #$0F                   ; 2
   tay                        ; 2
   lda LeftPF2MazeValues,y    ; 4
   sta leftPF2Value           ; 3
   jsr DrawGhostSprite        ; 6
;--------------------------------------
   lda #0                     ; 2
   sta ENAM0                  ; 3 = @14
   ldy waferIndex             ; 3
   lda mazeDots,y             ; 4
   lsr                        ; 2
   lsr                        ; 2
   lsr                        ; 2
   lsr                        ; 2
   and #7                     ; 2
   tay                        ; 2
   lda LFD3F,y                ; 4
   sta leftPF1Value           ; 3
   jsr DrawPacmanSprite       ; 6
;--------------------------------------
   ldy waferIndex             ; 3
   lda mazeDots,y             ; 4
   bpl LF13F                  ; 2
   lda #%01010000             ; 2
   bne LF141                  ; 3         unconditional branch
   
LF13F:
   lda #%00010000             ; 2
LF141:
   sta leftPF0Value           ; 3
   lda mazeDots+4,y           ; 4
   and #7                     ; 2
   tay                        ; 2
   lda LFD63,y                ; 4
   sta rightPF2Value          ; 3
   jsr DrawGhostSprite        ; 6
;--------------------------------------
       LDY    waferIndex     ;3
       LDA    mazeDots+4,Y   ;4
       LSR            ;2
       LSR            ;2
       LSR            ;2
       STA    rightPF0Value     ;3
       AND    #$07    ;2
       TAY            ;2
       LDA    LFD5B,Y ;4
       STA    rightPF1Value     ;3
       JSR    DrawPacmanSprite   ;6
       LDA    rightPF0Value     ;3
       LSR            ;2
       LSR            ;2
       LSR            ;2
       AND    #$03    ;2
       TAY            ;2
       LDA    LFD57,Y ;4
       STA    rightPF0Value     ;3
       JMP    BeginWaferKernel   ;3
       
LF176: LDY    waferIndex     ;3
       LDA    mazeDots+8,Y   ;4
       AND    #$07    ;2
       TAY            ;2
       LDA    LFD7B,Y ;4
       STA    leftPF2Value     ;3
       JSR    DrawGhostSprite   ;6
       LDA    #$00    ;2
       STA    ENAM0   ;3
       LDA    kernelEnableVitamin     ;3
       STA    ENABL   ;3
       LDY    waferIndex     ;3
       LDA    mazeDots+8,Y   ;4
       LSR            ;2
       LSR            ;2
       LSR            ;2
       AND    #$0F    ;2
       TAY            ;2
       LDA    LFD6B,Y ;4
       STA    leftPF1Value     ;3
       JSR    DrawPacmanSprite   ;6
       LDY    waferIndex     ;3
       LDA    mazeDots+8,Y   ;4
       BPL    LF1AC   ;2
       LDA    #$50    ;2
       BNE    LF1AE   ;2
LF1AC: LDA    #$10    ;2
LF1AE: STA    leftPF0Value     ;3
       LDA    mazeDots+12,Y   ;4
       AND    #$07    ;2
       TAY            ;2
       LDA    LFD63,Y ;4
       STA    rightPF2Value     ;3
       JSR    DrawGhostSprite   ;6
       LDY    waferIndex     ;3
       LDA    mazeDots+12,Y   ;4
       LSR            ;2
       LSR            ;2
       LSR            ;2
       STA    rightPF0Value     ;3
       AND    #$07    ;2
       TAY            ;2
       LDA    RightPF1MazeValues,Y ;4
       STA    rightPF1Value     ;3
       JSR    DrawPacmanSprite   ;6
       LDA    kernelEnableVitamin     ;3
       STA    ENAM1   ;3
       LDA    rightPF0Value     ;3
       LSR            ;2
       LSR            ;2
       LSR            ;2
       TAY            ;2
       LDA    RightPF0MazeValues,Y ;4
       STA    rightPF0Value     ;3
       JMP    BeginWaferKernel   ;3
       
.rightPF1ForWaferKernel
   lda rightPF1Value          ; 3
   sta PF1                    ; 3 = @47
   nop                        ; 2         waste 4 cycles
   nop                        ; 2
.rightPF2ForWaferKernel
   lda rightPF2Value          ; 3
   sta PF2                    ; 3 = @58
   lda #0                     ; 2         used to clear ghost graphic
   jmp .waferKernelSecondLine ; 3
       
BeginWaferKernel
   jsr DrawGhostSprite        ; 6
;--------------------------------------
   lda kernelSection          ; 3
   cmp #STARTING_BOX_SECTION  ; 2
   bne LF209                  ; 2+1
   lda #%01000000             ; 2         left part of box
   ora leftPF2Value           ; 3
   sta leftPF2Value           ; 3
   lda #%00100000             ; 2         right part of box
   ora rightPF0Value          ; 3
   sta rightPF0Value          ; 3
LF209:
   lda #0                     ; 2
   cpx pacmanOffset           ; 3
   bmi WaferKernel            ; 2
   ldy pacmanIndex            ; 3
   bmi WaferKernel            ; 2
   lda (pacmanPointer),y      ; 5
   dey                        ; 2
   sty pacmanIndex            ; 3
   
WaferKernel
   sta WSYNC
;--------------------------------------
   sta GRP1                   ; 3 = @03   draw pacman sprite
   lda leftPF0Value           ; 3
   sta PF0                    ; 3 = @09
   ldy #%00110000             ; 2
   sty CTRLPF                 ; 3 = @14   nonreflective playfield
   lda leftPF1Value           ; 3
   sta PF1                    ; 3 = @20
   lda leftPF2Value           ; 3
   sta PF2                    ; 3 = @26
   inx                        ; 2
   lda rightPF0Value          ; 3
   sta PF0                    ; 3 = @34
   cpx ghostOffset            ; 3
   bmi .rightPF1ForWaferKernel; 2+1
   lda rightPF1Value          ; 3
   sta PF1                    ; 3 = @45
   ldy ghostIndex             ; 3
   bmi .rightPF2ForWaferKernel; 2+1
   lda rightPF2Value          ; 3
   sta PF2                    ; 3 = @55
   lda (ghostPointer),y       ; 5
   dey                        ; 2
   sty ghostIndex             ; 3
.waferKernelSecondLine
   sta WSYNC
;--------------------------------------
   sta GRP0                   ; 3 = @03   draw the ghost sprite
   lda leftPF0Value           ; 3
   sta PF0                    ; 3 = @09
   lda leftPF1Value           ; 3
   sta PF1                    ; 3 = @15
   lda leftPF2Value           ; 3
   sta PF2                    ; 3 = @21
   nop                        ; 2         waste 4 cycles
   nop                        ; 2
   lda rightPF0Value          ; 3
   sta PF0                    ; 3 = @31
   cpx pacmanOffset           ; 3
   bmi .rightPF1SecondWafer   ; 2
   lda rightPF1Value          ; 3
   sta PF1                    ; 3 = @42
   ldy pacmanIndex            ; 3
   bmi .rightPF2SecondWafer   ; 2
   lda rightPF2Value          ; 3
   sta PF2                    ; 3 = @53
   lda (pacmanPointer),y      ; 5
   dey                        ; 2
   sty pacmanIndex            ; 3
.endWaferKernel
   sta WSYNC
;--------------------------------------
   sta GRP1                   ; 3 = @03   draw pacman sprite
   jmp LF287                  ; 3
       
.rightPF1SecondWafer
   lda rightPF1Value          ; 3
   sta PF1                    ; 3 = @43
   nop                        ; 2         waste 4 cycles
   nop                        ; 2
.rightPF2SecondWafer
   lda rightPF2Value          ; 3
   sta PF2                    ; 3 = @54
   lda #0                     ; 2         used to clear pacman graphic
   jmp .endWaferKernel        ; 3
       
LF287: LDY    mazeIndex     ;3
       LDA    MazePF0Values,Y ;4
       STA    PF0     ;3
       LDA    MazePF1Values,y ;4
       STA    PF1     ;3
       LDA    #$31    ;2
       STA    CTRLPF  ;3
       LDA    kernelPF2Value     ;3
       STA    PF2     ;3
       LDA    kernelSection     ;3
       CLC            ;2
       ADC    #$FF    ;2
       BPL    LF2A5   ;2
       JMP    LF360   ;3
       
LF2A5: STA    kernelSection     ;3
       LDA    #$00    ;2
       INX            ;2
       CPX    ghostOffset     ;3
       BMI    LF2B7   ;2
       LDY    ghostIndex     ;3
       BMI    LF2B7   ;2
       LDA    (ghostPointer),Y ;5
       DEY            ;2
       STY    ghostIndex     ;3
LF2B7: STA    WSYNC   ;3
       STA    GRP0    ;3
       LDY    #$00    ;2
       STY    ENAM1   ;3
       STY    $E2     ;3
       LDA    kernelSection     ;3
       TAY            ;2
       AND    #$01    ;2
       STA    mazeIndex     ;3
       INY            ;2
       TYA            ;2
       LSR            ;2
       STA    waferIndex     ;3
       JSR    LF067   ;6
       LDY    #$01    ;2
       LDA    frameCount     ;3
       AND    #$08    ;2
       BNE    LF2DA   ;2
       LDY    #$03    ;2
LF2DA: LDA    kernelSection     ;3
       BEQ    LF2E3   ;2
       CMP    #$06    ;2
       BNE    LF2EE   ;2
       DEY            ;2
LF2E3: LDA    $9A     ;3
       AND    LFE6C,Y ;4
       BEQ    LF2EE   ;2
       LDA    #$02    ;2
       STA    $E2     ;3
LF2EE: JSR    DrawPacmanSprite   ;6
       LDA    #$00    ;2
       STA    ENABL   ;3
       JSR    DrawGhostSprite   ;6
       LDA    $E2     ;3
       STA    ENAM0   ;3
       JSR    DrawPacmanSprite   ;6
       JSR    DrawGhostSprite   ;6
       LDY    mazeIndex     ;3
       LDA    LFF41,Y ;4
       STA    PF0     ;3
       LDA    LFE0F,Y ;4
       STA    PF1     ;3
       LDA    LFE11,Y ;4
       STA    PF2     ;3
LF313:
   jsr DrawPacmanSprite       ; 6
;--------------------------------------   
   lda gameState              ; 3 = @12   get the current game state
   ldy kernelSection          ; 3         get the kernel section
   cpy #VITAMIN_SECTION       ; 2         are we in the vitamin section
   beq .setForVitaminEnabling ; 2        branch if so
   lda #0                     ; 2
.setForVitaminEnabling
   sta kernelEnableVitamin    ; 3
   jsr DrawGhostSprite        ; 6
;--------------------------------------   
   ldy mazeIndex              ; 3 = @12
   lda MazePF2Values,y        ; 4
   ldy kernelSection          ; 3
   cpy #STARTING_BOX_SECTION  ; 2
   bne LF332                  ; 2
   lda #%01000000             ; 2
LF332:
   sta kernelPF2Value         ; 3
   jsr DrawPacmanSprite       ; 6
;--------------------------------------
   lda #0                     ; 2
   inx                        ; 2
   cpx ghostOffset            ; 3
   bmi LF347                  ; 2
   ldy ghostIndex             ; 3
   bmi LF347                  ; 2
   lda (ghostPointer),y       ; 5
   dey                        ; 2
   sty ghostIndex             ; 3
LF347:
   sta WSYNC
;--------------------------------------
   sta GRP0                   ; 3 = @03
   ldy mazeIndex              ; 3
   sta GRP0                   ; 3 = @09   waste 3 cycles???
   lda MazePF0Values,y        ; 4
   sta PF0                    ; 3 = @16
   lda MazePF1Values,y        ; 4
   sta PF1                    ; 3 = @23
   lda kernelPF2Value         ; 3
   sta PF2                    ; 3 = @29
   jmp LF0F4                  ; 3
       
LF360: LDA    #$00    ;2
       INX            ;2
       CPX    ghostOffset     ;3
       BMI    LF370   ;2
       LDY    ghostIndex     ;3
       BMI    LF370   ;2
       LDA    (ghostPointer),Y ;5
       DEY            ;2
       STY    ghostIndex     ;3
LF370: STA    WSYNC   ;3
       STA    GRP0    ;3
       JSR    LF067   ;6
       JSR    LF067   ;6
;--------------------------------------
   jsr LF067                  ; 9
   lda #%11111111             ; 2
   sta PF0                    ; 3 = @14   draw the last lines of the maze
   sta PF1                    ; 3 = @17
   lda #%01111111             ; 2         space used for the tunnel
   sta PF2                    ; 3 = @22
   lda #OVERSCAN_TIME         ; 2
   sta TIM64T                 ; 4         set the timer for overscan
   jsr DrawPacmanSprite       ; 6
   jsr DrawGhostSprite        ; 6
   jsr DrawPacmanSprite       ; 6
   lda #THREE_COPIES          ; 2
   ldy #$00                   ; 2
   sta WSYNC
;--------------------------------------
   sty PF0                    ; 3 = @03   clear the playfield registers
   sty PF1                    ; 3 = @06
   sty PF2                    ; 3 = @09
   sty REFP1                  ; 3 = @12   set player 1 to no reflect
   sta NUSIZ0                 ; 3 = @15
   sta NUSIZ1                 ; 3 = @18
   sta VDELP0                 ; 3 = @21   VDEL the player registers setting
   sta VDELP1                 ; 3 = @24   up for 6 digit display
   jsr ClearPlayerGraphics    ; 26
   lda gameTimer+1            ; 3
   sta COLUP1                 ; 3 = @56
   sta COLUP0                 ; 3 = @59
   ldx #7                     ; 2
   sta WSYNC
;--------------------------------------
.waste39Cycles
   dex                        ; 2
   bne .waste39Cycles         ; 2
   nop                        ; 2
   sta RESP0                  ; 3 = @44
   sta RESP1                  ; 3 = @47
   lda #HMOVE_R1              ; 2
   sta HMP0                   ; 3 = @52
   sta WSYNC
;--------------------------------------
   sta HMOVE                  ; 3
   stx COLUBK                 ; 3 = @06
   ldy #4                     ; 2         player 1 score offset
   lda $F5                    ; 3
   sta $D2                    ; 3
   jsr BCDToDigits            ; 6
;--------------------------------------
   lda playerState            ; 3 = @07   get the player state
   asl                        ; 2         shift game type into D7
   bpl LF3E1                  ; 2        branch if a 1player game
;
; draw second player digits
;
   ldy #5                     ; 2         player 2 score offset
   lda $F4                    ; 3
   sta $D2                    ; 3
   jsr BCDToDigits            ; 6
LF3E1
   lda #ONE_COPY              ; 2
   sta VDELP0                 ; 3         turn off vertical delay for both
   sta VDELP1                 ; 3         player graphics
   sta NUSIZ0                 ; 3         set the size of both players to
   sta NUSIZ1                 ; 3         on copy of each
   jmp DisplayRemainingLives  ; 3
       
BCDToDigits
   ldx #8                     ; 2
   lda #0                     ; 2
   sta $E1                    ; 3
   beq LowerNybbleBCDToDigit  ; 3
   
UpperNybbleBCDToDigit
   lda playerScoreL0,y        ; 4         get the player's score
   lsr                        ; 2         move the upper nybble to lower
   lsr                        ; 2         nybble
   lsr                        ; 2
   lsr                        ; 2
   tax                        ; 2         move the value to x
   beq .checkToSuppressZero   ; 2+1
   inc $E1                    ; 5
.checkToSuppressZero
   lda $E1                    ; 3
   bne .readNumberFontLSB     ; 2
   ldx #10                    ; 2         set x to Blank offset
.readNumberFontLSB
   lda GameFontTable,x        ; 4         get the LSB for the number to show
   ldx digitPointerOffset     ; 3         restore digitPointer index
   sta digitPointers,x        ; 4         stor number LSB in digit pointer
   dex                        ; 2
   dex                        ; 2
   cpx #4                     ; 2
   bne LF419                  ; 2
   lda #0                     ; 2
   beq LF41E                  ; 3         unconditional branch
   
LF419
   txa                        ; 2
   bne LowerNybbleBCDToDigit  ; 2
   lda $D2                    ; 3
LF41E:
   sta WSYNC
;--------------------------------------
   sta COLUBK                 ; 3         set color band for player score
LowerNybbleBCDToDigit SUBROUTINE
   stx digitPointerOffset     ; 3         save x for digitPointer index
   lda playerScoreL0,y        ; 4         get the player's score
   and #$0F                   ; 2         mask the upper nybbles
   tax                        ; 2         move the value to x
   beq .checkToSuppressZero   ; 2        branch if zero to show blank
   inc $E1                    ; 5
.checkToSuppressZero
   lda $E1                    ; 3
   bne .readNumberFontLSB     ; 2
   ldx #10                    ; 2         set x to Blank offset
.readNumberFontLSB
   lda GameFontTable,x        ; 4         get the LSB for the number to show
   ldx digitPointerOffset     ; 3         restore digitPointer index
   sta digitPointers,x        ; 4         store number LSB in digit pointer
   dex                        ; 2
   dex                        ; 2
   stx digitPointerOffset     ; 3         save x for pigitPointer index
   dey                        ; 2
   dey                        ; 2
   bpl UpperNybbleBCDToDigit  ; 2+1
   lda $E1                    ; 3
   bne SetDigitPointersMSB    ; 2
   lda #<zero                 ; 2
   sta digitPointers          ; 3
SetDigitPointersMSB
   lda #>NumberFonts          ; 2         get the MSB for the number fonts
   ldx #9                     ; 2
.setMSBLoop
   sta digitPointers,x        ; 4         store the value in the digit pointer
   dex                        ; 2         MSBs
   dex                        ; 2
   bpl .setMSBLoop            ; 2
   
SixDigitDisplay
   lda #H_FONT-1              ; 2
   sta loopCount              ; 3
.drawGraphicsLoop
   ldy loopCount              ; 3
   lda #0                     ; 2
   sta GRP0                   ; 3
   sta GRP0                   ; 3
   sta WSYNC
;--------------------------------------
   lda (digitPointers+8),y    ; 5
   sta GRP1                   ; 3 = @08
   lda (digitPointers+6),y    ; 5
   sta GRP0                   ; 3 = @16
   lda (digitPointers+4),y    ; 5
   sta tempCharHolder         ; 3
   lda (digitPointers+2),y    ; 5
   tax                        ; 2
   lda (digitPointers),y      ; 5
   tay                        ; 2
   lda tempCharHolder         ; 3
   sta GRP1                   ; 3 = @44
   stx GRP0                   ; 3 = @47
   sty GRP1                   ; 3 = @50
   sty GRP0                   ; 3 = @53
   dec loopCount              ; 5
   bpl .drawGraphicsLoop      ; 2
ClearPlayerGraphics
   lda #0                     ; 2
   sta GRP0                   ; 3
   sta GRP1                   ; 3
   sta GRP0                   ; 3
   sta GRP1                   ; 3
   rts                        ; 6
; c = current player (1 = player1 0 = player0)
DisplayRemainingLives
   tay                        ; 2
   lda playerState            ; 3         get the current player state
   bpl LF495                  ; 2        branch if current player is 0
   ldy #$03                   ; 2
LF495:
   ldx remainingLives         ; 3         load with current player lives
   jsr LFC68                  ; 6
   lda #0                     ; 2
   sta WSYNC
;--------------------------------------
   sta COLUBK                 ; 3 = @03
   ldy #$03                   ; 2
   lda playerState            ; 3         get the current player state
   bpl LF4A8                  ; 2        branch if current player is 0
   ldy #0                     ; 2
LF4A8:
   ldx tempRemainingLives     ; 3
   jsr LFC68                  ; 6
   ldx #6                     ; 2
   lda $F4                    ; 3
   sta COLUP1                 ; 3
   lda $F5                    ; 3
   sta COLUP0                 ; 3
.drawRemainingLivesLoop
   sta WSYNC
;--------------------------------------
   lda #%00000010             ; 2
   sta CTRLPF                 ; 3 = @05   non-reflectPF and SCORE color mode
   lda leftPF0Value           ; 3
   sta PF0                    ; 3 = @11
   lda leftPF1Value           ; 3
   sta PF1                    ; 3 = @17
   lda leftPF2Value           ; 3
   sta PF2                    ; 3 = @23
   nop                        ; 2
   nop                        ; 2
   nop                        ; 2
   lda rightPF0Value          ; 3
   sta PF0                    ; 3 = @35
   lda rightPF1Value          ; 3
   sta PF1                    ; 3 = @41
   lda rightPF2Value          ; 3
   sta PF2                    ; 3 = @47
   dex                        ; 2
   bne .drawRemainingLivesLoop; 2
   sta WSYNC
;--------------------------------------
   stx CTRLPF                 ; 3 = @03   clear SCORE mode (x = 0)
   stx COLUPF                 ; 3 = @06   set the playfield color to BLACK
   stx PF0                    ; 3 = @09   clear the playfield registers
   stx PF1                    ; 3 = @12
   stx PF2                    ; 3 = @15
   ldx gameTimer+1            ; 3
   bne .skipOverscanProcessing; 2
   jsr LFBAD                  ; 6
   lda ghostEatingDelay       ; 3
   bpl Overscan               ; 2
   dec ghostEatingDelay       ; 5
.skipOverscanProcessing
   jmp EndOverscan            ; 3

Overscan
   lda $E4
       BEQ    LF55B   ;2
       LDA    frameCount     ;3
       ROR            ;2
       BCC    LF55B   ;2
       DEC    $E4     ;5
       BNE    LF55B   ;2
       BIT    $9A     ;3
       LDA    $9A     ;3
       BPL    LF51A   ;2
       BVC    LF516   ;2
       AND    #$BF    ;2
       STA    $9A     ;3
       LDA    #$20    ;2
       STA    $E4     ;3
       BPL    LF55B   ;2
LF516: AND    #$7C    ;2
       STA    $9A     ;3
LF51A: LDA    gameState     ;3
       AND    #$40    ;2
       BEQ    LF553   ;2
       EOR    gameState     ;3
       STA    gameState     ;3
       JSR    LFC21   ;6
       BIT    playerState     ;3
       BVC    LF538   ;2
       LDA    tempRemainingLives     ;3
       BEQ    LF538   ;2
       JSR    LFB9F   ;6
       LDA    playerState     ;3
       EOR    #$80    ;2
       STA    playerState     ;3
LF538: LDA    remainingLives     ;3
       ORA    tempRemainingLives     ;3
       BEQ    LF548   ;2
       DEC    remainingLives     ;5
       LDA    #$08    ;2
       ORA    gameState     ;3
       STA    gameState     ;3
       BNE    LF55B   ;2
       
LF548: STA    gameState     ;3
       LDA    #$5F    ;2
       STA    gameTimer+1     ;3
       STA    pacmanVertPos     ;3
       JMP    EndOverscan
       
LF553: LDA    gameState     ;3
       BPL    LF55B   ;2
       AND    #$7F    ;2
       STA    gameState     ;3
LF55B: LDA    gameState     ;3
       BPL    LF573   ;2
       LDA    $99     ;3
       TAY            ;2
       DEY            ;2
       LDX    #$04    ;2
LF565: STA    $C0,X   ;4
       STY    $C4,X   ;4
       DEX            ;2
       STY    $C4,X   ;4
       STY    $C0,X   ;4
       DEX            ;2
       BNE    LF565   ;2
       BEQ    .skipOverscanProcessing   ;2
       
LF573:
   lda CXM1P                        ; read the player to missile collisions
   and CXP1FB                       ; and with playfield/ball collisions
   and #%01000000
   beq PacmanEatPowerPill
   ldy #ID_VITAMIN
   jsr IncrementScore
       LDY    #$01    ;2
       JSR    LFF43   ;6
   lda gameState                    ; get the current game state
   eor #FRUIT_VISIBLE               ; remove the visible fruit state
   sta gameState
   lda #VITAMIN_DURATION            ; reset the timer for the vitamin
   sta vitaminTimer
   bne .notEatingPowerPill          ; unconditional branch
       
PacmanEatPowerPill
   tax
   lda pacmanVertPos                ; get Pacman's vertical position
   cmp #NORTH_POWER_PILL_Y          ; check which area Pacman is currently in
   beq .pacmanInNorthPowerPillArea
   cmp #SOUTH_POWER_PILL_Y
   bne .notEatingPowerPill
   inx
.pacmanInNorthPowerPillArea
   lda pacmanHorizPos               ; get Pacman's horizontal position
   cmp #POWER_PILL_WEST
   beq LF5A9
   cmp #POWER_PILL_EAST
   bne .notEatingPowerPill
   inx
   inx
LF5A9:
   lda LFE6C,x
   tay
   and $9A
   beq .notEatingPowerPill
   tya
   eor #$FF
   and $9A
       ORA    #$C0    ;2
       STA    $9A     ;3
       LDY    #$A0    ;2
       LDA    gameState     ;3
       AND    #$20    ;2
       BEQ    LF5C4   ;2
       LDY    #$50    ;2
LF5C4: STY    $E4     ;3
       LDY    #ID_POWER_PILL
       JSR    IncrementScore   ;6
       LDY    #$02    ;2
       JSR    LFF43   ;6
       JMP    LF6AA   ;3
       
.notEatingPowerPill:
   LDA    frameCount     ;3
       AND    #$04    ;2
       BNE    LF61E   ;2
   lda CXPPMM                       ; read the player collisions
   bpl LF61E                        ; branch if no player collisions
       LDA    frameCount     ;3
       AND    #$03    ;2
       TAX            ;2
       LDA    $9A     ;3
       BPL    LF60B   ;2
       LDA    ghostDirections,X   ;4
       AND    #$08    ;2
       BNE    LF61E   ;2
       LDA    ghostDirections,X   ;4
       ORA    #$08    ;2
       STA    ghostDirections,X   ;4
       LDA    $9A     ;3
       AND    #$03    ;2
       TAY            ;2
       JSR    IncrementScore   ;6
       CPY    #$03    ;2
       BEQ    LF600   ;2
       INC    $9A     ;5
LF600: LDY    #$03    ;2
       JSR    LFF43   ;6
   lda #GHOST_EATING_DELAY
   sta ghostEatingDelay
   bne LF61E                        ; unconditional branch
       
LF60B: LDA    ghostDirections,X   ;4
       AND    #$08    ;2
       BNE    LF61E   ;2
       
   IF CHEAT_ENABLED
   
      REPEAT 13
      nop
      REPEND
      
   ELSE
   
      lda #$C0
      ora gameState
      sta gameState
      lda #$3F
      sta $E4
      jmp LF7BA
   
   ENDIF
       
LF61E:
   lda SWCHA                        ; read the joystick values
   ldy playerState
   bmi .determineJoystickValue
   lsr                              ; move player 0 joytick values to LSB
   lsr
   lsr
   lsr
.determineJoystickValue
   eor #$FF
   and #$0F                         ; only concerned about LSB value
   sta joystickValue
   beq .joystickNotMoved
   lda #0
   sta gameTimer
   
MOVE_RIGHT        = %10000000
MOVE_LEFT         = %01000000
MOVE_DOWN         = %00100000
MOVE_UP           = %00010000
NO_MOVE           = %11111111

.joystickNotMoved
   lda pacmanDirection
   and #%00100000
   beq LF666
   lda joystickValue
   lsr
   bcc .skipUpMovement
   lda pacmanDirection
   bmi LF656
LF644:
   and #MOVE_UP
   bne LF659
       LDA    #$3F    ;2
       EOR    pacmanVertPos     ;3
       AND    #$3F    ;2
       STA    pacmanVertPos     ;3
       LDA    #$C0    ;2
LF652: EOR    pacmanDirection     ;3
       STA    pacmanDirection     ;3
LF656: JMP    LF7BA   ;3

LF659: LDA    #$80    ;2
       BNE    LF652   ;2
       
.skipUpMovement
   lsr
   bcc LF656
       LDA    pacmanDirection     ;3
       BMI    LF644   ;2
       BPL    LF656   ;2
       
LF666: LDA    $85     ;3
       BNE    LF6AA   ;2
       LDY    $87     ;3
       LDA    LFE13,Y ;4
       LDX    pacmanHorizPos     ;3
       CPX    #$4C    ;2
       BEQ    LF67D   ;2
       LDX    pacmanDirection     ;3
       BPL    LF67D   ;2
       INY            ;2
       ORA    LFE13,Y ;4
LF67D: LSR            ;2
       BCC    LF6AA   ;2
       LSR            ;2
       TAX            ;2
       LDA    kernelSection     ;3
       ROL            ;2
       TAY            ;2
       LDA    LFE79,Y ;4
       TAY            ;2
       TXA            ;2
       AND    #$07    ;2
       TAX            ;2
       LDA    LFE6A,X ;4
       TAX            ;2
       AND    mazeDots,Y ;4
       BEQ    LF6AA   ;2
       TXA            ;2
       EOR    #$FF    ;2
       AND    mazeDots,Y ;4
       STA    mazeDots,Y ;5
       LDY    #ID_VIDEO_WAFER
       JSR    IncrementScore   ;6
       LDY    #$00    ;2
       JSR    LFF43   ;6
LF6AA: LDX    #$0F    ;2
       LDA    $9A     ;3
       AND    #$3C    ;2
LF6B0: ORA    mazeDots,X   ;4
       DEX            ;2
       BPL    LF6B0   ;2
       TAX            ;2
       BNE    LF6CE   ;2
       LDA    remainingLives     ;3
       CMP    #$09    ;2
       BEQ    LF6C0   ;2
       INC    remainingLives     ;5
LF6C0: LDA    $99     ;3
       CMP    #14
       BEQ    LF6C8   ;2
       INC    $99     ;5
LF6C8: JSR    ResetGameBoard   ;6
       JMP    LF7BA   ;3
       
LF6CE: LDX    #$00    ;2
       LDA    joystickValue     ;3
       STA    $D2     ;3
       BNE    LF6D9   ;2
       JMP    LF78A   ;3
       
LF6D9: LDY    pacmanDirection     ;3
       BPL    LF72D   ;2
LF6DD: LSR            ;2
       LSR            ;2
       AND    #$03    ;2
       BEQ    LF725   ;2
       LSR            ;2
       LDA    $85     ;3
       BNE    LF725   ;2
       LDA    $86     ;3
       BEQ    LF6F0   ;2
       BCC    LF71B   ;2
       BCS    LF700   ;2
LF6F0: LDY    $87     ;3
       BCC    LF70A   ;2
       LDA    $EE     ;3
       CMP    #$F9    ;2
       BEQ    LF725   ;2
       DEY            ;2
       LDA    LFE13,Y ;4
       BMI    LF725   ;2
LF700: LDA    #$01    ;2
       ORA    pacmanDirection     ;3
       STA    pacmanDirection     ;3
       LDY    #$01    ;2
       BNE    LF77B   ;2
LF70A: LDA    $C9     ;3
       CMP    #$03    ;2
       BNE    LF714   ;2
       CPY    #$38    ;2
       BEQ    LF725   ;2
LF714: INY            ;2
       INY            ;2
       LDA    LFE13,Y ;4
       BMI    LF725   ;2
LF71B: LDA    #$FE    ;2
       AND    pacmanDirection     ;3
       STA    pacmanDirection     ;3
       LDY    #$00    ;2
       BEQ    LF77B   ;2
LF725: LDA    $D2     ;3
       AND    #$F3    ;2
       BEQ    LF78A   ;2
       STA    $D2     ;3
LF72D: LDA    $D2     ;3
       AND    #$03    ;2
       BEQ    LF781   ;2
       LSR            ;2
       LDA    $86     ;3
       BNE    LF781   ;2
       LDA    pacmanHorizPos     ;3
       CMP    #$4C    ;2
       BNE    LF75B   ;2
       LDA    pacmanVertPos     ;3
       BEQ    LF751   ;2
       CMP    #$46    ;2
       BNE    LF75B   ;2
       LDA    $D2     ;3
       LSR            ;2
       LSR            ;2
       BCC    LF75B   ;2
       JSR    LFD26   ;6
       BNE    LF7BA   ;2
LF751: LDA    $D2     ;3
       LSR            ;2
       BCC    LF75B   ;2
       JSR    LFD32   ;6
       BNE    LF7BA   ;2
LF75B: LDA    $D2     ;3
       LSR            ;2
       LDA    $85     ;3
       BEQ    LF766   ;2
       BCC    LF779   ;2
       BCS    LF770   ;2
LF766: LDY    $87     ;3
       LDA    LFE13,Y ;4
       BCC    LF775   ;2
       ROL            ;2
       BPL    LF781   ;2
LF770: LDY    #$03    ;2
       JMP    LF77B   ;3
LF775: ROL            ;2
       ROL            ;2
       BPL    LF781   ;2
LF779: LDY    #$02    ;2
LF77B: JSR    LF9E5   ;6
       JMP    LF7BA   ;3
LF781: LDA    $D2     ;3
       AND    #$FC    ;2
       STA    $D2     ;3
       JMP    LF6DD   ;3
       
LF78A: JSR    LF793   ;6
       JSR    LF9EE   ;6
       JMP    LF7BA   ;3
       
LF793: LDA    $85     ;3
       ORA    $86     ;3
       BEQ    LF79A   ;2
       RTS            ;6

LF79A: LDA    objectDirections,X   ;4
       ROL            ;2
       BCS    LF7AD   ;2
       BPL    LF7A7   ;2
       JSR    LFB70   ;6
       JMP    LF7B8   ;3
       
LF7A7: JSR    LFB87   ;6
       JMP    LF7B8   ;3
       
LF7AD: BPL    LF7B5   ;2
       JSR    LFB36   ;6
       JMP    LF7B8   ;3
       
LF7B5: JSR    LFB5C   ;6
LF7B8: PLA            ;4
       PLA            ;4
LF7BA: LDA    pacmanDirection     ;3
       ROR            ;2
       BCC    EndOverscan   ;2
       LDA    #$08    ;2
       STA    REFP1   ;3
EndOverscan
.turnOffGameSounds
   ldx #0
   stx AUDV0                        ; turn off the sounds by reducing the
   stx AUDV1                        ; volume
   jsr LFF55
   ldx #1
   jsr LFF94
.waitTime
   lda INTIM                        ; wait for overscan to finish
   bne .waitTime
       
VerticalSync
   lda #$03
   sta WSYNC                        ; end last scan line
   sta VBLANK                       ; turn off TIA (D1 = 1)
   sta VSYNC                        ; start vertical sync
   sta CXCLR                        ; clear all collisions
   lda frameCount                   ; get the current fram count
   lsr                              ; divide by 8 (Pacman animation updated
   lsr                              ; every 8th frame)
   lsr
   tay                              ; save for Pacman animation
   lsr                              ; divide by 16 (ghost animation updated
                                    ; every 16th frame)
   and #$03                         ; mask value (0 <= a <= 3)
   tax
   lda GhostAnimationTable,x        ; load the ghost animation sprite
   sta ghostPointer                 ; store it in ghost pointer LSB
   lda gameState
   rol
   bpl .doPacmanAnimation

   
       LDA    $E4     ;3
       LSR            ;2
       LSR            ;2
       AND    #$0F    ;2
       TAX            ;2
       LDA    PacmanDeathAnimTable,X ;4
       BNE    .setPacmanPointer
       
.doPacmanAnimation
   tya                              ; move Pacman animation to accumulator
   and #$03                         ; mask value (0 <= a <= 3)
   tax
   lda PacmanAnimationTable,x       ; load the Pacman animation sprite
   ldx gameState
   bpl .setPacmanPointer

   lda PacmanAnimationTable
.setPacmanPointer
   sta pacmanPointer                ; store it in Pacman pointer LSB
   sta WSYNC                        ; first VSYNC line
   inc frameCount                   ; increment frame count each frame
   bne .secondVSyncLine
   inc gameTimer
   beq LF839

       DEC    vitaminTimer     ;5
       BNE    LF835   ;2
       LDY    #VITAMIN_DURATION
       LDA    gameState     ;3
       EOR    #FRUIT_VISIBLE
       STA    gameState     ;3
       AND    #FRUIT_VISIBLE
       BEQ    LF833   ;2
       LDY    #$03    ;2
       LDA    gameState     ;3
       AND    #$20    ;2
       BEQ    LF833   ;2
       DEY            ;2
LF833: STY    vitaminTimer     ;3
LF835: LDA    gameTimer+1     ;3
       BEQ    .secondVSyncLine   ;2
LF839: INC    gameTimer+1     ;5
       BEQ    LF839   ;2
.secondVSyncLine
   sta WSYNC                        ; second VSYNC line
   lda #>GameSprites                ; get the sprite MSB value
   sta ghostPointer+1               ; store it in ghost pointer MSB
   sta pacmanPointer+1              ; and Pacman pointer MSB
   lda pacmanVertPos
   clc
   adc #11
   sta pacmanOffset
   ldx #$07
   stx ghostIndex
   dex
   stx pacmanIndex
   ldx #$FF
   lda #BW_MASK                     ; load accumulator with console B/W mask
   and SWCHB                        ; and value to get B/W switch value
   bne .setToColor
   ldx #$0F
.setToColor
   txa
       LDX    gameTimer+1     ;3
       BEQ    LF865   ;2
       EOR    #$08    ;2
LF865: STA    $EF     ;3
       LDA    #$07    ;2
       STA    backgroundColor     ;3
       LDA    #$08    ;2
       STA    playfieldColor     ;3
       LDA    $AF     ;3
       STA    $F4     ;3
   lda #VBLANK_TIME
   sta TIM64T                       ; set timer for vertical blank time
   sta WSYNC                        ; last VSYNC line
   ldx #$00
   stx VSYNC                        ; end vertical sync (D1 = 0)
       LDA    $9B     ;3
       STA    $F5     ;3
       LDA    gameTimer+1     ;3
       BEQ    LF88A   ;2
   lda INPT4                        ; read the FIRE BUTTON
   bpl .resetGame                   ; reset game if pressed
LF88A:
   lda SWCHB                        ; read the console switches
   ror                              ; RESET now in carry
   bcs .checkForSelectPressed
.resetGame
   lda #$FF
   sta $CB
   jsr ResetGameVariables
   sta tempRemainingLives           ; clear the temporary remaining lives
   sta gameTimer+1                  ; reset the game timer
   lda #PLAY_STARTING_MUSIC
   sta gameState

       LDA    #11
       LDX    gameSelection     ;3
       CPX    #$08    ;2
       BPL    LF8A9   ;2
       LDA    #9
LF8A9: STA    $C0     ;3
       JSR    NewLevel   ;6
       LDA    playerState     ;3
       AND    #$7F    ;2
       STA    playerState     ;3
       ASL            ;2
       BPL    LF909   ;2
       JSR    LFB9F   ;6
       JSR    NewLevel   ;6
       INC    tempRemainingLives     ;5
       BNE    LF909   ;2
       
.checkForSelectPressed
   ror                              ; SELECT now in carry
   bcs LF909
   lda selectDebounce
   bne LF8FF
LF8C8:
   inc gameSelection
   lda #96
   sta pacmanVertPos
       LDA    #$10    ;2
       STA    gameState     ;3
       LDA    playerState     ;3
       EOR    #$40    ;2
       STA    playerState     ;3
       JSR    ResetGameVariables   ;6
       STA    AUDV0   ;3
       STA    AUDV1   ;3
       STA    $E8     ;3
       LDA    #$01    ;2
       STA    gameTimer+1     ;3
       STA    frameCount     ;3
       LDA    gameSelection     ;3
       CMP    #18
       BNE    LF8EF   ;2
       LDA    #2
LF8EF: STA    gameSelection     ;3
       LSR            ;2
       SEC            ;2
       SBC    #2
       AND    #$07    ;2
       BNE    LF8FB   ;2
       LDA    #8
LF8FB: STA    playerScoreL0     ;3
       STA    playerScoreL1     ;3
LF8FF: INC    selectDebounce     ;5
       LDA    selectDebounce     ;3
       AND    #$1F    ;2
       BNE    LF90D   ;2
       BEQ    LF8C8   ;2
LF909: LDY    #$00    ;2
       STY    selectDebounce     ;3
LF90D: LDA    #$DF    ;2
       AND    gameState     ;3
       STA    gameState     ;3
   lda #P1_DIFF_MASK
   ldx playerState
   bmi .determineGameDifficulty
   lsr
.determineGameDifficulty
   ldx #EXPERT                      ; assume EXPERT setting
   and SWCHB                        ; check the player's difficulty setting
   bne .setGameDifficulty
   ldx #AMATEUR
.setGameDifficulty
   txa
   ora gameState                    ; set the flag in gameState 
   sta gameState
   lda #$06
   sta $F3
   lda frameCount                   ; get the current frame count
   and #3                           ; make the value range from 0 - 3 (this
   tax                              ; determines which ghost is shown)
   tay
       LDA    $9A     ;3
       BPL    LF93D   ;2
       LDY    #$04    ;2
       AND    #$40    ;2
       BNE    LF93D   ;2
       INY            ;2
LF93D: STY    $F2     ;3
   inx
   lda objectDirections,x           ; get the direction of the ghost
   and #GHOST_EYES_ATTRIBUTE        ; see if the ghost is a set of eyes
   beq LF94C                        ; branch if not eyes
   lda #<GhostEyeSprite             ; get the eye sprite LSB
   sta ghostPointer                 ; store it in ghostPointer
   bne LF950                        ; unconditional branch
       
LF94C: LDA    ghostEatingDelay     ;3
       BMI    LF95D   ;2
LF950: LDA    gameState     ;3
       BMI    LF95D   ;2
       JSR    LF9AA   ;6
       JSR    LF9AA   ;6
       JSR    LF9AA   ;6
LF95D:
   lda objectHorizPos,x
   sta currentGhostHorizPos
   lda objectVertPos,x
   clc
   adc #GHOST_OFFSET
   sta ghostOffset
   lda objectDirections,x
   and #$20
   beq LF973
   ldy #$00
   jsr LFC8B
LF973: LDA    pacmanDirection     ;3
       AND    #$20    ;2
       BEQ    LF980   ;2
       LDY    #$01    ;2
       LDX    #$00    ;2
       JSR    LFC8B   ;6
LF980: LDA    #>GameColors;2
       STA    $D3     ;3
       LDA    #<ColorTable;2
       STA    $D2     ;3
       LDX    #$05    ;2
       LDA    $EF     ;3
       BMI    LF992   ;2
       LDA    #<BWTable;2
       STA    $D2     ;3
LF992: LDY    backgroundColor,X   ;4
       LDA    ($D2),Y ;5
       EOR    gameTimer+1     ;3
       AND    $EF     ;3
       STA    backgroundColor,X   ;4
       DEX            ;2
       BPL    LF992   ;2
       LDA    $F3     ;3
       STA    COLUP1  ;3
       LDA    $F2     ;3
       STA    COLUP0  ;3
       JMP    MainLoop   ;3
       
LF9AA:
   lda objectDirections,x           ; get the direction the object is moving
   and #$08
   beq LF9D2
   lda objectVertPos,x
   cmp #STARTING_BOX_Y
   bne LF9D2
   lda objectHorizPos,x
   cmp #88
   bne LF9C0
   ldy #$01
   bne LF9E5
   
LF9C0:
   cmp #STARTING_BOX_X
   bne LF9D2
   lda $9A
   bmi LF9E4
   lda objectDirections,x
   and #%11110111
   sta objectDirections,x
   ldy #$00
   beq LF9E5
       
LF9D2: LDA    objectDirections,X   ;4
       AND    #MOVE_DOWN
       BNE    LF9E4   ;2
       JSR    LFBAD   ;6
       JSR    LFA26   ;6
       LDA    objectDirections,X   ;4
       AND    #MOVE_DOWN
       BEQ    LF9EE   ;2
LF9E4: RTS            ;6

LF9E5: LDA    objectDirections,X   ;4
       AND    #$3F    ;2
       ORA    LFE63,Y ;4
       STA    objectDirections,X   ;4
LF9EE: LDA    $C0,X   ;4
       ASL            ;2
       ASL            ;2
       ASL            ;2
       ASL            ;2
       CLC            ;2
       ADC    $C0,X   ;4
       STA    $C0,X   ;4
       BCC    LF9E4   ;2
       LDY    #$00    ;2
       LDA    objectDirections,X   ;4
       AND    #$EF    ;2
       STA    objectDirections,X   ;4
       ROL            ;2
       BPL    LFA09   ;2
       DEY            ;2
       BMI    LFA0A   ;2
LFA09: INY            ;2
LFA0A: TYA            ;2
       BCS    LFA1A   ;2
       ADC    objectHorizPos,X   ;4
       CMP    #$02    ;2
       BEQ    LFA19   ;2
       CMP    #$96    ;2
       BEQ    LFA19   ;2
       STA    objectHorizPos,X   ;4
LFA19: RTS            ;6

LFA1A: CLC            ;2
       ADC    objectVertPos,X   ;4
       BMI    LFA25   ;2
       CMP    #$47    ;2
       BEQ    LFA25   ;2
       STA    objectVertPos,X   ;4
LFA25: RTS            ;6

LFA26: LDA    $86     ;3
       ORA    $85     ;3
       BNE    LF9E4   ;2
       LDA    objectDirections,X   ;4
       AND    #$10    ;2
       BNE    LF9E4   ;2
       LDA    gameTimer+1     ;3
       BEQ    LFA39   ;2
       JMP    LFAB9   ;3
       
LFA39: LDA    objectDirections,X   ;4
       AND    #$08    ;2
       BEQ    LFA49   ;2
       LDA    #$58    ;2
       STA    $D3     ;3
       LDA    #$1F    ;2
       STA    $D2     ;3
       BNE    LFA99   ;2
       
LFA49: LDA    objectHorizPos,X   ;4
       CMP    #$4C    ;2
       BNE    LFA63   ;2
       LDA    $CB     ;3
       AND    #$0F    ;2
       BNE    LFA63   ;2
       LDA    objectVertPos,X   ;4
       BNE    LFA5C   ;2
       JMP    LFD32   ;3
       
LFA5C: CMP    #$46    ;2
       BNE    LFA63   ;2
       JMP    LFD26   ;3
       
LFA63: LDA    pacmanHorizPos     ;3
       STA    $D3     ;3
       LDA    pacmanVertPos     ;3
       STA    $D2     ;3
       LDA    $9A     ;3
       BPL    LFA82   ;2
       LDA    pacmanHorizPos     ;3
       CLC            ;2
       ADC    #$60    ;2
       EOR    #$FF    ;2
       STA    $D3     ;3
       LDA    pacmanVertPos     ;3
       CLC            ;2
       ADC    #$B1    ;2
       EOR    #$FF    ;2
       JMP    LFA99   ;3
       
LFA82: DEC    $C4,X   ;6
       BNE    LFA99   ;2
       LDA    $99     ;3
       LSR            ;2
       TAY            ;2
       LDA    LFE6F,Y ;4
       STA    $C4,X   ;4
       TXA            ;2
       LSR            ;2
       LSR            ;2
       BCC    LFAB9   ;2
       INC    $C4,X   ;6
       JMP    LFAB9   ;3
       
LFA99: LDA    objectHorizPos,X   ;4
       CMP    $D3     ;3
       BEQ    LFAAA   ;2
       BCC    LFAA7   ;2
       JSR    LFB70   ;6
       JMP    LFAAA   ;3
       
LFAA7: JSR    LFB87   ;6
LFAAA: LDA    objectVertPos,X   ;4
       CMP    $D2     ;3
       BCC    LFAB6   ;2
       JSR    LFB36   ;6
       JMP    LFAB9   ;3
       
LFAB6: JSR    LFB5C   ;6
LFAB9: LDA    objectDirections,X   ;4
       ROL            ;2
       BCS    LFAC2   ;2
       BMI    LFAE0   ;2
       BPL    LFAD2   ;2
LFAC2: BPL    LFAEE   ;2
       JSR    LFBE0   ;6
       BNE    LFACC   ;2
       JSR    LFB36   ;6
LFACC: JSR    LFB19   ;6
       JSR    LFB36   ;6
LFAD2: JSR    LFBE0   ;6
       BNE    LFADA   ;2
       JSR    LFB87   ;6
LFADA: JSR    LFAFC   ;6
       JSR    LFB87   ;6
LFAE0: JSR    LFBE0   ;6
       BNE    LFAE8   ;2
       JSR    LFB70   ;6
LFAE8: JSR    LFAFC   ;6
       JSR    LFB70   ;6
LFAEE: JSR    LFBE0   ;6
       BNE    LFAF6   ;2
       JSR    LFB5C   ;6
LFAF6: JSR    LFB19   ;6
       JSR    LFB5C   ;6
LFAFC: JSR    LFBE0   ;6
       JSR    LFB05   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB05: BNE    LFB10   ;2
       JSR    LFB36   ;6
       JSR    LFB5C   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB10: JSR    LFB5C   ;6
       JSR    LFB36   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB19: JSR    LFBE0   ;6
       JSR    LFB22   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB22: BNE    LFB2D   ;2
       JSR    LFB70   ;6
       JSR    LFB87   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB2D: JSR    LFB87   ;6
       JSR    LFB70   ;6
       PLA            ;4
       PLA            ;4
       RTS            ;6

LFB36: LDA    $C9     ;3
       BEQ    LFB5B   ;2
       LDY    $87     ;3
       LDA    LFE13,Y ;4
       ROL            ;2
       BPL    LFB5B   ;2
       LDY    #$03    ;2
LFB44: TXA            ;2
       BEQ    LFB50   ;2
       LDA    objectDirections,X   ;4
       AND    #$C0    ;2
       CMP    LFE67,Y ;4
       BEQ    LFB5B   ;2
LFB50: LDA    objectDirections,X   ;4
       AND    #$3F    ;2
       ORA    LFE63,Y ;4
       STA    objectDirections,X   ;4
       PLA            ;4
       PLA            ;4
LFB5B: RTS            ;6

LFB5C: LDA    $C9     ;3
       CMP    #$07    ;2
       BEQ    LFB5B   ;2
       LDY    $87     ;3
       LDA    LFE13,Y ;4
       ROL            ;2
       ROL            ;2
       BPL    LFB5B   ;2
       LDY    #$02    ;2
       JMP    LFB44   ;3
       
LFB70: LDY    $87     ;3
       LDA    $C9     ;3
       CMP    #$03    ;2
       BNE    LFB7C   ;2
       CPY    #$3E    ;2
       BEQ    LFB5B   ;2
LFB7C: DEY            ;2
       LDA    LFE13,Y ;4
       BMI    LFB5B   ;2
       LDY    #$01    ;2
       JMP    LFB44   ;3
       
LFB87: LDY    $87     ;3
       LDA    $C9     ;3
       CMP    #$03    ;2
       BNE    LFB93   ;2
       CPY    #$38    ;2
       BEQ    LFB5B   ;2
LFB93: INY            ;2
       INY            ;2
       LDA    LFE13,Y ;4
       BMI    LFB5B   ;2
       LDY    #$00    ;2
       JMP    LFB44   ;3
       
LFB9F: LDX    #$13    ;2
LFBA1: LDA    currentPlayerVars,X   ;4
       LDY    temporaryPlayerVars,X   ;4
       STA    temporaryPlayerVars,X   ;4
       STY    currentPlayerVars,X   ;4
       DEX            ;2
       BPL    LFBA1   ;2
       RTS            ;6

LFBAD:
   ldy #0
   lda objectVertPos,x              ; get the object's vertical position
   beq LFBBB
.determineKernelSectionLoop
   iny
   sec
   sbc #10
   beq LFBBB   ;2
   bpl .determineKernelSectionLoop
LFBBB:
   sty $C9                          ; save the kernel section
   sta $85
   lda objectHorizPos,x             ; get the object's horizontal position
   and #$03
   sta $86
   lda $C9                          ; get the kernel section
   lsr                              ; move D0 to carry (if odd kernel section)
   php                              ; push carry on the stack
   lda objectHorizPos,x             ; get the object's horizontal position
   lsr
   lsr                              ; divide the value by 4
   plp                              ; pull carry from stack (if odd kernel section)
   bcc LFBD3                        ; branch if even kernel section
       CLC            ;2
       ADC    #40
LFBD3: STA    $87     ;3
       ASL            ;2
       ASL            ;2
       ROR    $C9     ;5
       ORA    $C9     ;3
       ROL    $C9     ;5
       STA    $EE     ;3
       RTS            ;6

LFBE0: LDA    $CB     ;3
       ASL            ;2
       EOR    $CB     ;3
       ASL            ;2
       ASL            ;2
       ROL    $CB     ;5
       LDA    $CB     ;3
       AND    #$07    ;2
       TAY            ;2
       LDA    LFE6A,Y ;4
       AND    $CB     ;3
       RTS            ;6

NewLevel
   lda #9
   sta $AF
   lda #10
   sta $9B
   lda #STARTING_NUM_LIVES
   sta remainingLives
   lda gameSelection
   sec
   sbc #2
   and #6
   clc
   adc #4
   sta $99
ResetGameBoard
   ldx #15
   lda #%11111111
.setMazeDotsLoop
   sta mazeDots,x
   dex
   bpl .setMazeDotsLoop
   lda #%011111111
   sta mazeDots+6                   ; right of box
   lda #%11111110
   sta mazeDots+2                   ; left of box
   lda #%00111100                   ; left side/right side D7 energizer on
   sta $9A                          ; energizers
LFC21:
   lda gameState
   ora #$80
   sta gameState
   lda #$3C
   sta $E4
   ldx #4
   lda #MID_PLAYFIELD_X
LFC2F:
   sta objectHorizPos,x
   ldy #STARTING_BOX_Y
   sty objectVertPos,x
   ldy #$00
   sty objectDirections,x
   dex
   bpl LFC2F
   lda #PACMAN_STARTING_Y
   sta pacmanVertPos
   lda #$80
   sta pacmanDirection
   rts

IncrementScore
   stx $E1                          ; save the value of x
   ldx #$00                         ; assume this is for player 1
   lda playerState
   bpl .increaseScore
   inx                              ; for player 2
.increaseScore
   sed                              ; set to decimal mode
   clc
   lda playerScoreL0,x
   adc ScoreTableLo,y
   sta playerScoreL0,x
   lda playerScoreM0,x
   adc ScoreTableMid,y
   sta playerScoreM0,x
   lda playerScoreH0,x
   adc #$00
   sta playerScoreH0,x
   cld                              ; clear decimal mode
   ldx $E1                          ; restore x register
   rts

LFC68:
   txa                        ; 2
   beq LFC6D                  ; 2
   lda #%01000000             ; 2
LFC6D:
   sta leftPF0Value,y         ; 5
   lda LFF1B,x                ; 4
   sta leftPF1Value,y         ; 5
   lda Blank+1,x              ; 4
   sta leftPF2Value,y         ; 5
   rts                        ; 6

ResetGameVariables
   lda #0
   ldx #5
.resetScore
   sta playerScore,x
   dex
   bpl .resetScore
   sta remainingLives
   sta tempRemainingLives
   rts

LFC8B:
   lda objectDirections,x
   and #$10                         ; going down tunnel????
   bne LFCA9
   dec objectVertPos,x              ; move object up
   bne LFCFC
   lda objectDirections,x
   bmi LFC9D
   lda #0
   beq LFC9F
   
; %01000000 = left
; %00100000 = down
; %00010000 = right

LFC9D: LDA    #MAX_Y    ;2
LFC9F: STA    objectVertPos,X   ;4
       LDA    objectDirections,X   ;4
       ORA    #$10    ;2
       STA    objectDirections,X   ;4
       BNE    LFCFC   ;2
       
LFCA9: LDA    objectDirections,X   ;4
       ROL            ;2
       BCS    LFD00   ;2
       BPL    LFCE7   ;2
       INC    objectVertPos,X   ;6
LFCB2: LDA    objectVertPos,X   ;4
       CMP    #$0B    ;2
       BNE    LFCCA   ;2
       LDA    #$00    ;2
       STA    objectVertPos,X   ;4
       LDA    #$0B    ;2
       STA    ghostOffset,Y ;5
       LDA    objectDirections,X   ;4
       AND    #$0F    ;2
       ORA    #$80    ;2
       STA    objectDirections,X   ;4
       RTS            ;6

LFCCA: CMP    #$06    ;2
       BPL    LFCE1   ;2
       STA    $DB,Y ;5
       TAX            ;2
       CLC            ;2
       LDA    ScoreTableMid+1,x
       LDX    LFF19,Y ;4
       ADC    ghostPointer,X   ;4
       STA    ghostPointer,X   ;4
       LDA    #$08    ;2
       BNE    LFCE3   ;2
       
LFCE1: LDA    objectVertPos,X   ;4
LFCE3: STA    ghostOffset,Y ;5
       RTS            ;6

LFCE7: INC    objectVertPos,X   ;6
       LDA    #MAX_Y    ;2
       CMP    objectVertPos,X   ;4
       BNE    LFCE1   ;2
       LDA    objectDirections,X   ;4
       AND    #$0F    ;2
       ORA    #$60    ;2
       STA    objectDirections,X   ;4
LFCF7: LDA    LFF25,Y ;4
       STA    objectVertPos,X   ;4
LFCFC: LDA    #$70    ;2
       BNE    LFCE3   ;2
       
LFD00
   bmi LFD18
   dec objectVertPos,x
   lda #81
   cmp objectVertPos,x
   bne LFCE1
   lda #70
   sta objectVertPos,x
   lda objectDirections,x
   and #$0F
   ora #MOVE_LEFT | MOVE_RIGHT
   sta objectDirections,x
   bne LFCFC
   
LFD18:
   dec objectVertPos,x
   bpl LFCB2
   lda objectDirections,x
   and #$0F
   ora #MOVE_RIGHT | MOVE_DOWN
   sta objectDirections,x
   bne LFCF7
   
LFD26:
   lda objectDirections,x
   and #$0F
   ora #MOVE_DOWN | MOVE_UP
   sta objectDirections,x
   lda #81
   bne LFD3C
   
LFD32:
   lda objectDirections,x
   and #$0F
   ora #%11110000
   sta objectDirections,x
   lda #11
LFD3C:
   sta objectVertPos,x
   rts

LFD3F: .byte $08,$0A,$28,$2A,$88,$8A,$A8,$AA
LeftPF2MazeValues
RightPF0MazeValues
   .byte $00,$40,$10,$50,$04,$44,$14,$54,$01,$41,$11,$51,$05,$45,$15,$55
   
LFD57: .byte $00,$80,$20,$A0

LFD5B
   .byte $01,$05,$11,$15,$41,$45,$51,$55
LFD63: .byte $80,$A0,$88,$A8,$82,$A2,$8A,$AA
LFD6B: .byte $00,$02,$08,$0A,$20,$22,$28,$2A,$80,$82,$88,$8A,$A0,$A2,$A8,$AA
LFD7B: .byte $08,$88,$28,$A8,$09,$89,$29,$A9

RightPF1MazeValues
   .byte $80,$81,$84,$85,$90,$91,$94,$95

GameSprites
GhostSprites
GhostAnimation0
   .byte $AA ; |X.X.X.X.|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $99 ; |X..XX..X|
   .byte $DD ; |XX.XXX.X|
   .byte $7E ; |.XXXXXX.|
   .byte $3C ; |..XXXX..|
GhostAnimation1
   .byte $55 ; |.X.X.X.X|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $99 ; |X..XX..X|
   .byte $BB ; |X.XXX.XX|
   .byte $7E ; |.XXXXXX.|
   .byte $3C ; |..XXXX..|
GhostAnimation2
   .byte $AA ; |X.X.X.X.|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $BB ; |X.XXX.XX|
   .byte $99 ; |X..XX..X|
   .byte $7E ; |.XXXXXX.|
   .byte $3C ; |..XXXX..|
GhostAnimation3
   .byte $55 ; |.X.X.X.X|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $FF ; |XXXXXXXX|
   .byte $DD ; |XX.XXX.X|
   .byte $99 ; |X..XX..X|
   .byte $7E ; |.XXXXXX.|
   .byte $3C ; |..XXXX..|
   
GhostAnimationTable
   .byte <GhostAnimation0,<GhostAnimation1,<GhostAnimation2,<GhostAnimation3

PacmanSprites
PacmanStationary
PacmanAnimation0
   .byte $38 ; |..XXX...|
   .byte $7C ; |.XXXXX..|
   .byte $FE ; |XXXXXXX.|
   .byte $FE ; |XXXXXXX.|
   .byte $FE ; |XXXXXXX.|
   .byte $6C ; |.XX.XX..|
PacmanAnimation1
   .byte $38 ; |..XXX...|
   .byte $7C ; |.XXXXX..|
   .byte $FE ; |XXXXXXX.|
   .byte $E0 ; |XXX.....|
   .byte $FE ; |XXXXXXX.|
   .byte $6C ; |.XX.XX..|
PacmanAnimation2
   .byte $38 ; |..XXX...|
   .byte $7E ; |.XXXXXX.|
   .byte $E0 ; |XXX.....|
   .byte $C0 ; |XX......|
   .byte $E0 ; |XXX.....|
   .byte $6C ; |.XX.XX..|
   .byte $38 ; |..XXX...|
   
PacmanAnimationTable
   .byte <PacmanAnimation0,<PacmanAnimation1
   .byte <PacmanAnimation2,<PacmanAnimation1

GhostEyeSprite
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $E7 ; |XXX..XXX|
   .byte $A5 ; |X.X..X.X|
   .byte $E7 ; |XXX..XXX|
   .byte $00 ; |        |

PacmanDeathSprites
DeathAnimation0
   .byte $3C ; |..XXXX..|
   .byte $7E ; |.XXXXXX.|
   .byte $C3 ; |XX....XX|
   .byte $C3 ; |XX....XX|
   .byte $E7 ; |XXX..XXX|
   .byte $66 ; |.XX..XX.|
   .byte $24 ; |..X..X..|
DeathAnimation1
   .byte $18 ; |...XX...|
   .byte $3C ; |..XXXX..|
   .byte $7E ; |.XXXXXX.|
   .byte $E7 ; |XXX..XXX|
   .byte $E7 ; |XXX..XXX|
   .byte $C3 ; |XX....XX|
   .byte $C3 ; |XX....XX|
DeathAnimation2
   .byte $3C ; |..XXXX..|
   .byte $7E ; |.XXXXXX.|
   .byte $E7 ; |XXX..XXX|
   .byte $C3 ; |XX....XX|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
DeathAnimation3
   .byte $FF ; |XXXXXXXX|
   .byte $7E ; |.XXXXXX.|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
DeathAnimation4
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $14 ; |...X.X..|
   .byte $08 ; |....X...|
   .byte $14 ; |...X.X..|
   .byte $00 ; |........|
DeathAnimation5
   .byte $00 ; |........|
   .byte $22 ; |..X...X.|
   .byte $14 ; |...X.X..|
   .byte $00 ; |........|
   .byte $14 ; |...X.X..|
DeathAnimation6
   .byte $22 ; |..X...X.|
   .byte $00 ; |........|
   .byte $41 ; |.X.....X|
   .byte $00 ; |........|
   .byte $41 ; |.X.....X|
   .byte $00 ; |........|
   .byte $22 ; |..X...X.|
   
PacmanDeathAnimTable
   .byte <DeathAnimation6,<DeathAnimation5
   .byte <DeathAnimation4,<DeathAnimation4
   .byte <DeathAnimation3,<DeathAnimation3
   .byte <DeathAnimation2,<DeathAnimation2
   .byte <DeathAnimation1,<DeathAnimation1
   .byte <DeathAnimation0,<DeathAnimation0,<DeathAnimation0
   .byte <PacmanStationary,<PacmanStationary,<PacmanStationary
   
MazePF0Values
   .byte $10,$10
MazePF1Values
   .byte $08
MazePF2Values
   .byte $00,$08
   
LFE0F: .byte $C9,$39
LFE11: .byte $C9,$CF
LFE13: .byte $80,$20,$01,$00,$45,$00,$29,$00,$0D,$60,$11,$00,$15,$20,$00,$80
       .byte $60,$19,$00,$1D,$03,$00,$67,$00,$80,$20,$0B,$00,$00,$6F,$00,$13
       .byte $20,$17,$40,$1B,$00,$3F,$00,$80,$80,$40,$01,$00,$25,$00,$49,$00
       .byte $80,$60,$0D,$00,$11,$40,$15,$00,$79,$00,$1D,$00,$00,$03,$60,$07
       .byte $00,$4B,$00,$0F,$00,$73,$00,$80,$40,$17,$20,$1B,$00,$5F,$00,$80
LFE63: .byte $10,$50,$90,$D0
LFE67: .byte $40,$00,$C0
LFE6A: .byte $80,$40
LFE6C: .byte $20,$10
LFE6E: .byte $08
LFE6F: .byte $04,$02,$01,$02,$03,$05,$07,$08,$0A,$0C
LFE79: .byte $08,$0C,$03,$07,$0B,$0F,$02,$06,$0A,$0E,$01,$05,$09,$0D,$00,$04

Copyright0
   .byte $79 ; |.XXXX..X|
   .byte $85 ; |X....X.X|
   .byte $B5 ; |X.XX.X.X|
   .byte $A5 ; |X.X..X.X|
   .byte $B5 ; |X.XX.X.X|
   .byte $85 ; |X....X.X|
   .byte $79 ; |.XXXX..X|
Copyright1
   .byte $17 ; |...X.XXX|
   .byte $15 ; |...X.X.X|
   .byte $15 ; |...X.X.X|
   .byte $77 ; |.XXX.XXX|
   .byte $55 ; |.X.X.X.X|
   .byte $55 ; |.X.X.X.X|
   .byte $77 ; |.XXX.XXX|
Copyright2
   .byte $41 ; |.X.....X|
   .byte $41 ; |.X.....X|
   .byte $41 ; |.X.....X|
   .byte $41 ; |.X.....X|
   .byte $41 ; |.X.....X|
   .byte $41 ; |.X.....X|
   .byte $40 ; |.X......|
Copyright3
   .byte $49 ; |.X..X..X|
   .byte $49 ; |.X..X..X|
   .byte $49 ; |.X..X..X|
   .byte $C9 ; |XX..X..X|
   .byte $49 ; |.X..X..X|
   .byte $49 ; |.X..X..X|
   .byte $BE ; |X.XXXXX.|
Copyright4
   .byte $55 ; |.X.X.X.X|
   .byte $55 ; |.X.X.X.X|
   .byte $55 ; |.X.X.X.X|
   .byte $D9 ; |XX.XX..X|
   .byte $55 ; |.X.X.X.X|
   .byte $55 ; |.X.X.X.X|
   .byte $99 ; |X..XX..X|
NumberFonts
zero
   .byte $3C ; |..XXXX..|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
six
   .byte $3C ; |..XXXX..|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
   .byte $7C ; |.XXXXX..|
   .byte $60 ; |.XX.....|
   .byte $62 ; |.XX...X.|
eight
   .byte $3C ; |..XXXX..|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
   .byte $3C ; |..XXXX..|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
nine
   .byte $3C ; |..XXXX..|
   .byte $46 ; |.X...XX.|
   .byte $06 ; |.....XX.|
   .byte $3E ; |..XXXXX.|
   .byte $66 ; |.XX..XX.|
   .byte $66 ; |.XX..XX.|
three
   .byte $3C ; |..XXXX..|
   .byte $46 ; |.X...XX.|
   .byte $06 ; |.....XX.|
   .byte $0C ; |....XX..|
   .byte $06 ; |.....XX.|
   .byte $46 ; |.X...XX.|
   .byte $3C ; |..XXXX..|
four
   .byte $0C ; |....XX..|
   .byte $0C ; |....XX..|
   .byte $7E ; |.XXXXXX.|
   .byte $4C ; |.X..XX..|
   .byte $2C ; |..X.XX..|
   .byte $1C ; |...XXX..|
   .byte $0C ; |....XX..|
seven
   .byte $18 ; |...XX...|
   .byte $18 ; |...XX...|
   .byte $08 ; |....X...|
   .byte $04 ; |.....X..|
   .byte $02 ; |......X.|
   .byte $62 ; |.XX...X.|
two
   .byte $7E ; |.XXXXXX.|
   .byte $60 ; |.XX.....|
   .byte $60 ; |.XX.....|
   .byte $3C ; |..XXXX..|
   .byte $06 ; |.....XX.|
   .byte $46 ; |.X...XX.|
five
   .byte $7C ; | XXXXX..|
   .byte $46 ; |.X...XX.|
   .byte $06 ; |.....XX.|
   .byte $7C ; |.XXXXX..|
   .byte $60 ; |.XX.....|
   .byte $60 ; |.XX.....|
one
   .byte $7E ; |.XXXXXX.|
   .byte $18 ; |...XX...|
   .byte $18 ; |...XX...|
   .byte $18 ; |...XX...|
   .byte $18 ; |...XX...|
   .byte $78 ; |.XXXX...|
   .byte $38 ; |..XXX...|
Blank
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   .byte $00 ; |........|
   
LFEF2
   .byte $01,$05,$15,$55
   
GameFontTable
   .byte <zero,<one,<two,<three,<four,<five,<six,<seven,<eight,<nine,<Blank
   .byte <Copyright4,<Copyright3,<Copyright2,<Copyright1,<Copyright0

ScoreTableLo
   .byte FIRST_GHOST_VALUE
   .byte SECOND_GHOST_VALUE
   .byte THIRD_GHOST_VALUE
   .byte FOURTH_GHOST_VALUE
   .byte VIDEO_WAFER_VALUE
   .byte POWER_PILL_VALUE   
   
ScoreTableMid
   .byte FIRST_GHOST_VALUE >> 8
   .byte SECOND_GHOST_VALUE >> 8
   .byte THIRD_GHOST_VALUE >> 8
   .byte FOURTH_GHOST_VALUE >> 8
   .byte VIDEO_WAFER_VALUE >> 8
   .byte POWER_PILL_VALUE >> 8
   .byte VITAMIN_VALUE >> 8
   
LFF13: .byte $06,$05,$04,$03,$02,$01
LFF19: .byte $00,$02
LFF1B: .byte $00,$00,$80,$A0,$A8,$AA,$AA,$AA,$AA,$AA
LFF25: .byte $10,$40,$08,$0A,$0C,$0E

GameColors
ColorTable
   .byte $FC,$EC,$DC,$CC,$7A,$5A,$FB,$84,$F7,$44,$C4
BWTable
   .byte $0E,$0E,$0E,$0E,$09,$04,$0F,$00,$07,$04,$0A

LFF41: .byte $90,$F0
LFF43: LDA    LFFE9,Y ;4
       AND    $E8     ;3
       BNE    LFF54   ;2
       LDA    LFE6E,Y ;4
       STA    $E8     ;3
       LDA    LFFED,Y ;4
       STA    $E9     ;3
LFF54: RTS            ;6

LFF55: LDA    $E8     ;3
       LSR            ;2
       BCC    LFF67   ;2
       LDA    #$04    ;2
       STA    $D3     ;3
       LDA    $E9     ;3
       AND    #$1F    ;2
       TAY            ;2
       EOR    #$0F    ;2
       BCS    LFF82   ;2
LFF67: LSR            ;2
       BCC    LFF6E   ;2
LFF6A: LDA    #$0D    ;2
       BNE    LFF7F   ;2
LFF6E: LSR            ;2
       BCC    LFF74   ;2
       JMP    LFF6A   ;3
LFF74: LSR            ;2
       BCC    LFF93   ;2
       LDY    #$09    ;2
       STY    $D3     ;3
       LDA    $E9     ;3
       BNE    LFF82   ;2
LFF7F: TAY            ;2
       STA    $D3     ;3
LFF82: DEC    $E9,X   ;6
       BNE    LFF8B   ;2
       LDA    #$00    ;2
       STA    $E8     ;3
       RTS            ;6

LFF8B: STA    AUDV0,X ;4
       LDA    $D3     ;3
       STA    AUDC0,X ;4
       STY    AUDF0,X ;4
LFF93: RTS            ;6

LFF94: LDA    #$08    ;2
       BIT    gameState     ;3
       BVC    LFFA6   ;2
       LDA    $E4     ;3
       STA    AUDV0   ;3
       LSR            ;2
       STA    AUDF0   ;3
       LDA    #$04    ;2
       STA    AUDC0   ;3
       RTS            ;6

LFFA6: BEQ    LFFD3   ;2
       LDA    $E4     ;3
       BNE    LFFB2   ;2
       LDA    #$F7    ;2
       AND    gameState     ;3
       STA    gameState     ;3
LFFB2: LSR            ;2
       LSR            ;2
       LSR            ;2
       AND    #$07    ;2
       TAX            ;2
       CPX    #$04    ;2
       BPL    LFFE8   ;2
       LDA    LFFF1,X ;4
       STA    AUDF0   ;3
       LDA    LFFF5,X ;4
       STA    AUDF1   ;3
       LDA    #$04    ;2
       STA    AUDC0   ;3
       STA    AUDC1   ;3
       LDA    #$08    ;2
       STA    AUDV0   ;3
       STA    AUDV1   ;3
       RTS            ;6

LFFD3: LDA    $9A     ;3
       ASL            ;2
       BPL    LFFE8   ;2
       LDA    #$04    ;2
       STA    $D3     ;3
       LDA    frameCount     ;3
       LSR            ;2
       AND    #$0F    ;2
       TAY            ;2
       EOR    #$0F    ;2
       LSR            ;2
       JMP    LFF8B   ;3
LFFE8: RTS            ;6

LFFE9: .byte $07,$03,$01,$00
LFFED: .byte $09,$18,$10,$30
LFFF1: .byte $08,$04,$0C,$04
LFFF5: .byte $14,$18,$14,$18
   org $FFFC, 0
   .word Start
   .word 0
